//+------------------------------------------------------------------+
//|                                                  BTSignal_v1.mq4 |
//|                           Copyright  2010, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"
//---- indicator settings
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_width1 1
#property indicator_width2 1

//---- indicator parameters
extern string     BT1            = "BT1 settings";
extern double     stoch_period            =    9;
extern double     stoch_max               =   53;
extern double     stoch_min               =   47;
extern double     atr_current_norm_factor =0.435;
extern double     atr_before_norm_factor  =  1.5;
extern double     atr_period              =    7;
extern int        atr_before_step         =    1;

extern string     BT2            = "BT2 settings";
extern bool       spread_eq_0             =true;

extern string     IXO            = "I-XO settings";
extern int        BoxSize                 =   15;

extern double     ATR_Ratio               =    1;
extern int        NumBars                 =  100;
extern int        AlertMode               =    1;    // Alert Mode: 0-off,1-on
extern int        EmailMode               =    0; 
//---- indicator buffers
double UpSignal[];
double DnSignal[]; 
double trend[];

bool   UpTrendAlert=false, DownTrendAlert=false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   string short_name;
//---- drawing settings
   IndicatorBuffers(3);
      
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- indicator short name
   IndicatorShortName("BTSignal");
   SetIndexLabel(0,"UpSignal");
   SetIndexLabel(1,"DnSignal");
   
//---- indicator buffers mapping
   SetIndexBuffer(0,UpSignal);
   SetIndexBuffer(1,DnSignal);
   SetIndexBuffer(2,trend);
   SetIndexEmptyValue(2,0);
//---- initialization done
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int CountedBars=IndicatorCounted();
   if(Bars<=NumBars) return(0);
   
//---- check for possible errors
   if (CountedBars < 1) 
      for(int i=Bars-1;i>0;i--) 
      {
      UpSignal[i] = EMPTY_VALUE; 
      DnSignal[i] = EMPTY_VALUE;
      }
   
   for(i=NumBars; i>=0; i--)
   { 
   double BT1_sell = iCustom(NULL,0,"BrainTrend1_all_in_one1",stoch_period,stoch_max,stoch_min,atr_current_norm_factor,
			            atr_before_norm_factor,atr_period,atr_before_step,0,NumBars,0,i);
   
   double BT1_buy  = iCustom(NULL,0,"BrainTrend1_all_in_one1",stoch_period,stoch_max,stoch_min,atr_current_norm_factor,
			            atr_before_norm_factor,atr_period,atr_before_step,0,NumBars,1,i);
   
   double BT2_sell= iCustom(NULL,0,"BrainTrend2_all_in_one1",NumBars,spread_eq_0,0,0,i);
   double BT2_buy = iCustom(NULL,0,"BrainTrend2_all_in_one1",NumBars,spread_eq_0,0,1,i);
   
   bool b_BT1 = BT1_buy > 0 && BT1_buy < 2*Close[i] && BT1_sell == EMPTY_VALUE; 
   bool s_BT1 = BT1_buy == EMPTY_VALUE && BT1_sell > 0 && BT1_sell < 2*Close[i]; 
   bool b_BT2 = BT2_buy > 0 && BT2_buy < 2*Close[i] && BT2_sell == EMPTY_VALUE; 
   bool s_BT2 = BT2_buy == EMPTY_VALUE && BT2_sell > 0 && BT2_sell < 2*Close[i]; 
   
   double XOUP = iCustom(NULL,0,"I_XO_A_H_5d",BoxSize,0,i);
   double XODN = iCustom(NULL,0,"I_XO_A_H_5d",BoxSize,1,i); 
   
   bool b_XO = XOUP > 0 && XODN == 0;
   bool s_XO = XOUP == 0 && XODN < 0;
   
   trend[i]=trend[i+1]; 
   if (b_BT1 && b_BT2 && b_XO) trend[i]= 1; 
   if (s_BT1 && s_BT2 && s_XO) trend[i]=-1; 
      
      if(trend[i]>0)
	   {
	   if (trend[i+1]<=0) UpSignal[i] = Low[i]-ATR_Ratio*iATR(NULL,0,10,i);
	   DnSignal[i]=EMPTY_VALUE; 
	   }
	   else
	   if(trend[i]<0)
	   {
	   if (trend[i+1]>=0) DnSignal[i] = High[i]+ATR_Ratio*iATR(NULL,0,10,i);
	   UpSignal[i]=EMPTY_VALUE; 
	   }
   	         
//----------   
      if (i==0 && (AlertMode > 0 || EmailMode>0))
      {
         if (trend[i+1] > 0 && Volume[0]>1)
         {
            if (trend[i+2]<0 && !UpTrendAlert)
	         {
	         string Message = " "+Symbol()+" M"+Period()+": Signal for BUY";
	         if(AlertMode > 0) Alert (Message); 
	         if(EmailMode > 0) SendMail("From BTSignal", Message); 
	         UpTrendAlert=true; DownTrendAlert=false;
	         } 
	      }
	      else
	      if (trend[i+1] < 0 && Volume[0]>1)
	      {
            if ( trend[i+2]>0 && !DownTrendAlert)
	         {
	         Message = " "+Symbol()+" M"+Period()+": Signal for SELL";
	         if(AlertMode > 0) Alert (Message); 
	         if(EmailMode > 0) SendMail("From BTSignal", Message); 
            DownTrendAlert=true; UpTrendAlert=false;     
	         }
	      } 	  
      }	
	} 	         

//---- done
   return(0);
}
//+------------------------------------------------------------------+